﻿#targetengine "test"

//ドキュメント確認
app.activate();
if(app.documents.length==0){
alert("InDesignドキュメントを開いてから実行してください。");
exit() ;
}else if(app.documents.length>1){
	alert("複数のInDesignドキュメントを開いている場合、最前面ドキュメントのみが処理対象となります。");
	}
if(app.documents[0].saved==false){
		alert("処理対象のInDesignドキュメントを保存してから実行してください。");
		exit() ;
}

//外部テキストファイルを用意
saveFolderPath = app.documents[0].filePath; // ドキュメントの保存フォルダ
fileObj = new File(saveFolderPath +"/【"+app.documents[0].name+"】.txt");
fileObj.encoding="UTF8";

//一覧を生成
var doc = app.documents[0] ;
var myList=new String;
myList=("");

//綴じ方を確認（縦組みか横組みか／ページの流れ）→toji
var toji ;
if(doc.documentPreferences.pageBinding==PageBindingOptions.RIGHT_TO_LEFT){toji="tate"}else{toji="yoko"};

//ページ幅を確認→pWidth
var pWidth ;
pWidth = doc.documentPreferences.pageWidth;

//検索オプションGrep
app.changeGrepPreferences = NothingEnum.nothing;
app.findGrepPreferences = NothingEnum.nothing;
app.findChangeGrepOptions.includeHiddenLayers = true;//非表示レイヤーを含めるかどうか
app.findChangeGrepOptions.includeMasterPages = true;//マスターページを含めるかどうか
app.findChangeGrepOptions.includeFootnotes = true;//脚注を含めるかどうかか

var conf_obj = {};

var swAry = [];	//スウォッチ名の配列
for (i = 0; i < app.activeDocument.swatches.length; i++) {
	newSw = app.activeDocument.swatches[i].name.replace (/None/,'');	//Noneは文字なしに
	swAry.push( newSw );	//配列にスウォッチ名を追加
	}
var stAry = [ "" , "ベタ" , "太い - 太い" , "太い - 細い" , "太い - 細い - 太い" , "細い - 太い" , "細い - 太い - 細い" , "二重線" , "三重線" , "点線 (3 & 2)" , "点線 (4 & 4)" , "左斜線ハッシュ" , "右斜線ハッシュ" , "直線ハッシュ" , "点" , "波状" , "ホワイトダイヤモンド" , "句点" ];

//ここからダイアログ（Window）の設定
var dlg = new Window('dialog', "書式を指定", undefined, {borderless: false});	//borderlessは上の帯の有無らしい

//下線エリア
dlg.panel = dlg.add('panel');
dlg.panel.alignChildren = 'left';

//チェックボックス1
var ch1 = dlg.panel.add ('checkbox', undefined, "下線設定で検索");

//ドロップダウンリスト11
var ddl11 = dlg.panel.add('dropdownlist',  [0,0,240,23], stAry);
ddl11.title = '　　下線の種類：';
ddl11.selection = conf_obj['place'] === undefined ? 0 : conf_obj['place'];	//何番目を初期表示とするか（らしい）

//ドロップダウンリスト12
var ddl12 = dlg.panel.add('dropdownlist',  [0,0,240,23], swAry);
ddl12.title = '　　　下線の色：';
ddl12.selection = conf_obj['place'] === undefined ? 0 : conf_obj['place'];	//何番目を初期表示とするか（らしい）

//ドロップダウンリスト11・12を操作不可に
ddl11.enabled = false;
ddl12.enabled = false;

//チェックボックス1が選択されたら操作可に
ch1.onClick = function (){
    ddl11.enabled = ch1.value;
    ddl12.enabled = ch1.value;
    }

//打ち消し線エリア
dlg.panel = dlg.add('panel');
dlg.panel.alignChildren = 'left';

//チェックボックス2
var ch2 = dlg.panel.add ('checkbox', undefined, "打ち消し線設定で検索");

//ドロップダウンリスト21
var ddl21 = dlg.panel.add('dropdownlist', [0,0,240,23], stAry);
ddl21.title = '打ち消し線の種類：';
ddl21.selection = conf_obj['place'] === undefined ? 0 : conf_obj['place'];	//何番目を初期表示とするか（らしい）

//ドロップダウンリスト22
var ddl22 = dlg.panel.add('dropdownlist', [0,0,240,23], swAry);
ddl22.title = '　打ち消し線の色：';
ddl22.selection = conf_obj['place'] === undefined ? 0 : conf_obj['place'];	//何番目を初期表示とするか（らしい）

//ドロップダウンリスト21・22を操作不可に
ddl21.enabled = false;
ddl22.enabled = false;

//チェックボックス2が選択されたら操作可に
ch2.onClick = function (){
    ddl21.enabled = ch2.value;
    ddl22.enabled = ch2.value;
    }

//文字色エリア
dlg.panel = dlg.add('panel');
dlg.panel.alignChildren = 'left';

//チェックボックス3
var ch3 = dlg.panel.add ('checkbox', undefined, "文字色で検索");

//ドロップダウンリスト31
var ddl31 = dlg.panel.add('dropdownlist',  [0,0,240,23], swAry);
ddl31.title = '　　　　　文字色：';
ddl31.selection = conf_obj['place'] === undefined ? 0 : conf_obj['place'];	//何番目を初期表示とするか（らしい）

//ドロップダウンリスト31を操作不可に
ddl31.enabled = false;

//チェックボックス3が選択されたら操作可に
ch3.onClick = function (){
    ddl31.enabled = ch3.value;
    }

//buttonエリア
dlg.group = dlg.add('group');
var ok_btn = dlg.group.add('button', undefined,"OK", {name:'ok'});
var can_btn = dlg.group.add('button',undefined,"Cancel", {name:'cancel'});

ok_btn.onClick = function () {
var setting_obj = {};
dlg.close();
}
dlg.show();

if(ch1.value==true && ddl11.selection != ""){	//チェックがあり、選択線種が文字なしでない場合
//alert(stAry[ddl11.selection.index]);	//ドロップダウンリストで選択したもの
app.findGrepPreferences.underlineType = stAry[ddl11.selection.index] ;
app.findGrepPreferences.underline = true;
}
if(ch1.value==true && ddl12.selection != ""){	//チェックがあり、かつ選択スウォッチが文字なしでない場合
//alert(swAry[ddl12.selection.index]);	//ドロップダウンリストで選択したもの
app.findGrepPreferences.underlineColor = swAry[ddl12.selection.index] ;
app.findGrepPreferences.underline = true;
}

if(ch2.value==true && ddl21.selection != "" ){	//チェックがあり、選択スウォッチが文字なしでない場合
//alert(stAry[ddl21.selection.index]);	//ドロップダウンリストで選択したもの
app.findGrepPreferences.strikeThroughType = stAry[ddl21.selection.index] ;
app.findGrepPreferences.strikeThru = true;
}
if(ch2.value==true && ddl22.selection != "" ){	//チェックがあり、選択スウォッチが文字なしでない場合
//alert(swAry[ddl22.selection.index]);	//ドロップダウンリストで選択したもの
app.findGrepPreferences.strikeThroughColor = swAry[ddl22.selection.index] ;
app.findGrepPreferences.strikeThru = true;
}

if(ch3.value==true && ddl31.selection != ""){	//チェックがあり、選択文字色が文字なしでない場合
//alert(swAry[ddl31.selection.index]);	//ドロップダウンリストで選択したもの
app.findGrepPreferences.fillColor= swAry[ddl31.selection.index] ;
}

app.findGrepPreferences.findWhat=""

var gr=doc.findGrep(); // 検索だけ
var grl=gr.length; 

for (i=0; i<grl; i++) { 
try {
var ho = gr[i].horizontalOffset;    //先頭文字の左上X座標
var myTF = gr[i].parentTextFrames[0];   //テキストフレーム
var pageName = myTF.parentPage.name;    //ページ
 
//先頭文字は左右どちらのページに存在するか
var myPosition = "lt" ;
if( ho > pWidth ){myPosition = "rt" };

//場合分け（テキストフレームの所属ページが奇数か偶数か確認しながら）
if( toji == "tate" && myPosition == "lt" && pageName % 2 == 0){ pageName = pageName*1+1 };  //縦組み・座標が左なのにページが偶数→プラス1
if( toji == "tate" && myPosition == "rt" && pageName % 2 != 0){ pageName = pageName*1-1 };  //縦組み・座標が右なのにページが奇数→マイナス1
if( toji == "yoko" && myPosition == "lt" && pageName % 2 != 0){ pageName = pageName*1-1 };  //横組み・座標が左なのにページが奇数→マイナス1
if( toji == "yoko" && myPosition == "rt" && pageName % 2 == 0){ pageName = pageName*1+1 };  //横組み・座標が右なのにページが偶数→プラス1

myList=(myList+"\r"+gr[i].contents+"\t"+pageName);

}
catch (e) {}
}
myList=myList.replace(/[\u0007\u0003\u200C\n\u0004]/g,"");	//「ここまでインデント」文字、先頭文字スタイルの終了文字、結合なし、強制改行、脚注番号マーカを削除
myList=myList.replace(/^\r/g,""); 

flag = fileObj.open("w");
if (flag){
fileObj.writeln(myList);
fileObj.close();

////ソート/////

//文字列を生成
//var myList=new String;
myList=("");

//配列を作成
var ary = [];
flagA = fileObj.open("r");
if (flagA)
{
countA = 0;
TAB = String.fromCharCode(9);	// タブコード

while(!fileObj.eof)
{
textA = fileObj.readln();	//　１行読み込む
txtItemA = textA.split(TAB);	//　タブコードで分割
ary.push(txtItemA);//配列の最後に行を追加
countA++;
}
var  lineNum = countA ;	//行数
var rowNum = txtItemA.length;	//列数
}
function funcCompare(a, b) {
	if (a[0] < b[0]) return -1;
	if (a[0] > b[0]) return 1;

	if (a[rowNum-1]*1 < b[rowNum-1]*1) return -1;
	if (a[rowNum-1]*1 > b[rowNum-1]*1) return 1;
	return 0;
}
var newAry=ary.sort(funcCompare);
var aLength = newAry.length;

for( i=0 ; i<aLength ; i++ ){
var newTxt = newAry[i].join( "\t" );
myList = myList + newTxt + "\r" ;
}
flag = fileObj.open("w");
if (flag){
fileObj.writeln(myList);
fileObj.close();
}

/////重複削除/////

//var myList=new String;
myList=("");

//配列を作成
var ary = [];
flagA = fileObj.open("r");
if (flagA)
{
countA = 0;
while(!fileObj.eof)
{
textA = fileObj.readln();	//　１行読み込む
txtItemA = textA.split(TAB);	//　タブコードで分割
ary.push(txtItemA);//配列の最後に行を追加
countA++;
}
var rowNum = txtItemA.length;	//列数
}

//語句（1列目）とノンブル（最終列）が重複していたら行を削除する。
for( i=ary.length-1 ; i>0 ; i-- ){
if( ary[i][0]==ary[i-1][0] && ary[i][rowNum-1]==ary[i-1][rowNum-1] ){
//alert(ary[i][0]);
ary.splice(i, 1);
}
}

//語句（1列目）の重複があったらノンブルを「, 」区切りでまとめる。
for( j=ary.length-1 ; j>0 ; j-- ){
if( ary[j][0]==ary[j-1][0] ){
//alert(ary[i][0]);
ary[j-1][rowNum-1]=ary[j-1][rowNum-1]+", "+ary[j][rowNum-1];
ary.splice(j, 1);
}
}

//ファイルに書き込み保存。
for( k=0 ; k<ary.length ; k++ ){
var newTxt = ary[k].join( "\t" );
myList = myList + newTxt + "\r" ;
}
flag = fileObj.open("w");
if (flag){
fileObj.writeln(myList);
fileObj.close();
};
var docName = app.documents[0].name.replace(/\.indd/g,"");;

now = new Date();
myYear = now.getFullYear();
myMonth=now.getMonth()+1;
myDate=now.getDate();
myHours=now.getHours();
myMinutes=now.getMinutes();
mySeconds=now.getSeconds();
nowTime= myYear +"-"+myMonth+"-"+myDate+"-"+myHours+"-"+myMinutes+"-"+mySeconds;

fileObj.rename( docName+"（索引）"+ nowTime+".txt");
}else{
alert("ファイルが作成できません。アクセス権があるか確認してください");
}

//※検索条件を検索ダイアログで確認できるよう以下の2行をオフにしています。
//　検索条件をクリアしたほうが良いなら行頭の「//」を消してください。

app.changeGrepPreferences = NothingEnum.nothing;
app.findGrepPreferences = NothingEnum.nothing;