﻿flag = confirm("フォルダ内の索引用テキストファイルを合体ソートします。");
if (flag == true) {

app.activate();

folderObj = Folder.selectDialog("フォルダを選択してください"); 
if(folderObj){

var fldPthName=folderObj.fsName;//パスを含むフォルダ名
var fldPth=folderObj.path;//フォルダのパス
var fileList = folderObj.getFiles();

//隠しファイルを削除
for(i=fileList.length-1;i>-1;i--){
var fileName; //仮のファイル名
//ファイル名が"."から始まるもの（隠しファイル）のfileNameの値を"invFile"にする
fileName=fileList[i].name.replace(/^\..+/g,"invFile");
//fileNameの値が"invFile"だったらファイルを削除
if(fileName=="invFile"){
    fileList[i].remove();
    }
}
//外部テキストファイルを用意
now = new Date();
myYear = now.getFullYear();
myMonth=now.getMonth()+1;
myDate=now.getDate();
myHours=now.getHours();
myMinutes=now.getMinutes();
mySeconds=now.getSeconds();
nowTime=myYear +"-"+myMonth+"-"+myDate+"-"+myHours+"-"+myMinutes+"-"+mySeconds;
fileObj = new File(fldPth +"/"+folderObj.name+"（合体索引）"+nowTime+".txt");
fileObj.encoding="UTF8";

var ngList=new String;
ngList=("");

//ファイルを再読み込み
fileList = folderObj.getFiles();
//alert(fileList.length+"個のファイルがあります");

for(j=0;j<fileList.length;j++){
flagA = fileList[j].open("r");
if (flagA==true)
{
textA = fileList[j].read();	//　読み込む
}
//alert(textA);
ngList = ngList + textA ;
fileList[j].close();
}

flag = fileObj.open("w");
if (flag){
fileObj.writeln(ngList);
fileObj.close();
}
}
}

////ソート/////

//文字列を生成
//var ngList=new String;
ngList=("");

//配列を作成
var ary = [];
flagA = fileObj.open("r");
if (flagA)
{
countA = 0;
TAB = String.fromCharCode(9);	// タブコード

while(!fileObj.eof)
{
textA = fileObj.readln();	//　１行読み込む
txtItemA = textA.split(TAB);	//　タブコードで分割
ary.push(txtItemA);//配列の最後に行を追加
countA++;
}
var  lineNum = countA ;	//行数
var rowNum = txtItemA.length;	//列数
}
function funcCompare(a, b) {
	if (a[0] < b[0]) return -1;
	if (a[0] > b[0]) return 1;

	if (a[rowNum-1]*1 < b[rowNum-1]*1) return -1;
	if (a[rowNum-1]*1 > b[rowNum-1]*1) return 1;
	return 0;
}
var newAry=ary.sort(funcCompare);
var aLength = newAry.length;

for( i=0 ; i<aLength ; i++ ){
var newTxt = newAry[i].join( "\t" );
ngList = ngList + newTxt + "\r" ;
}
flag = fileObj.open("w");
if (flag){
fileObj.writeln(ngList);
fileObj.close();
}

/////重複削除/////

//var ngList=new String;
ngList=("");

//配列を作成
var ary = [];
flagA = fileObj.open("r");
if (flagA)
{
countA = 0;
while(!fileObj.eof)
{
textA = fileObj.readln();	//　１行読み込む
txtItemA = textA.split(TAB);	//　タブコードで分割
ary.push(txtItemA);//配列の最後に行を追加
countA++;
}
var rowNum = txtItemA.length;	//列数
}

//語句（1列目）とノンブル（最終列）が重複していたら行を削除する。
for( i=ary.length-1 ; i>0 ; i-- ){
if( ary[i][0]==ary[i-1][0] && ary[i][rowNum-1]==ary[i-1][rowNum-1] ){
//alert(ary[i][0]);
ary.splice(i, 1);
}
}

//語句（1列目）の重複があったらノンブルを「, 」区切りでまとめる。
for( j=ary.length-1 ; j>0 ; j-- ){
if( ary[j][0]==ary[j-1][0] ){
//alert(ary[i][0]);
ary[j-1][rowNum-1]=ary[j-1][rowNum-1]+", "+ary[j][rowNum-1];
ary.splice(j, 1);
}
}

//ファイルに書き込み保存。
for( k=0 ; k<ary.length ; k++ ){
var newTxt = ary[k].join( "\t" );
ngList = ngList + newTxt + "\r" ;
}
ngList=ngList.replace(/^\r/g,""); 

flag = fileObj.open("w");
if (flag){
fileObj.writeln(ngList);
fileObj.close();
};